﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.IO;
using Microsoft.Win32;

namespace WPF.Kapitel14.FlowDocument
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent();
        }

        private void OpenMenuItem_Click(object sender, RoutedEventArgs e)
        {
            OpenFileDialog dialog = new OpenFileDialog();
            dialog.Filter = "Text (*.txt)|*.txt|XAML (*.xaml)|*.xaml|RTF (*.rtf)|*.rtf";
            if (dialog.ShowDialog() == true)
            {
                string format = DataFormats.Text;
                if (Path.GetExtension(dialog.FileName) == ".xaml")
                    format = DataFormats.Xaml;
                else if (Path.GetExtension(dialog.FileName) == ".rtf")
                    format = DataFormats.Rtf;

                TextRange textRange = new TextRange(
                    RichTextBox1.Document.ContentStart,
                    RichTextBox1.Document.ContentEnd);
                using (FileStream stream = File.Open(dialog.FileName, FileMode.Open))
                {
                    textRange.Load(stream, format);
                }
            }
        }

        private void SaveMenuItem_Click(object sender, RoutedEventArgs e)
        {
            SaveFileDialog dialog = new SaveFileDialog();
            dialog.Filter = "Text (*.txt)|*.txt|XAML (*.xaml)|*.xaml|RTF (*.rtf)|*.rtf";
            if (dialog.ShowDialog() == true)
            {
                string format = DataFormats.Text;
                if (Path.GetExtension(dialog.FileName) == ".xaml")
                    format = DataFormats.Xaml;
                else if (Path.GetExtension(dialog.FileName) == ".rff")
                    format = DataFormats.Rtf;

                TextRange textRange = new TextRange(
                    RichTextBox1.Document.ContentStart,
                    RichTextBox1.Document.ContentEnd);
                using (FileStream stream = File.Create(dialog.FileName))
                {
                    textRange.Save(stream, format);
                }
            }
        }
    }
}
