﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace TouchManipulationApp
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            MatrixTransform transform = B1.RenderTransform as MatrixTransform;
            var matrix = transform.Matrix;
            matrix.Rotate(22);

            transform.Matrix = matrix;
        }

        private void Window_ManipulationStarting(object sender, ManipulationStartingEventArgs e)
        {
            e.ManipulationContainer = this;
            e.Handled = true;
        }

        private void Window_ManipulationDelta(object sender, ManipulationDeltaEventArgs e)
        {
            // Änderung (delta) und Ursprung abfragen
            var delta = e.DeltaManipulation;
            var center = e.ManipulationOrigin;

            // Element und Transformation aus EventArgs holen
            var element = e.Source as UIElement;
            var transform = element.RenderTransform as MatrixTransform;
            var matrix = transform.Matrix;

            // Gestik auf Transformation anwenden
            matrix.ScaleAt(delta.Scale.X, delta.Scale.Y, center.X, center.Y);
            matrix.RotateAt(delta.Rotation, center.X, center.Y);
            matrix.Translate(delta.Translation.X, delta.Translation.Y);

            transform.Matrix = matrix;
            e.Handled = true;
        }
    }
}
